#include <iostream>
#include <cstdio>
#include <queue>
#include <cstdlib>
#include <cstring>
#include <string>

using namespace std;


typedef struct element {
	int x, y;
	int orient;
	int comm;
} ELEM;

int main() {
	int h, w;
	char hw[100][100];
	int status[100][100][4][10][3];

	int n_comm;
	char comms[10];

	const int up = 3;
	const int down = 1;
	const int left = 2;
	const int right = 0;

	queue<ELEM> my_queue;

	while (cin >> h >> w) {
		memset(status, 0, 100*100*4*10*3*sizeof(int));


		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) { 
				cin >> hw[j][i];

				if (hw[j][i] == '.') {
					ELEM tmp;
					tmp.x = i;
					tmp.y = j;
					tmp.orient = up;
					tmp.comm = 0;
					my_queue.push(tmp);
				}
			}
		}

		cin >> n_comm;
		string str_comm;
		cin >> str_comm;
		for (int i = 0; i < n_comm; i++) {comms[i] = str_comm[i]; }
		//nactene vstupy
		
		while (!my_queue.empty()) {
			ELEM e = my_queue.front();
			my_queue.pop();
		//	cout << e.x << ":" << e.y << ", " << e.orient << ", " << e.comm << endl;
			status[e.x][e.y][e.orient][e.comm][0] = 1;
			if (comms[e.comm] == 'S') {
				if (e.orient == up && e.y != 0 && hw[e.x][e.y - 1] != 'X' 
						&& !status[e.x][e.y - 1][e.orient][(e.comm + 1)% n_comm][0]){
					e.y -= 1;
					e.comm = (e.comm + 1) % n_comm;
					//cout << "--SU " << e.x << ":" << e.y << ", " << e.orient << ", " << e.comm << endl;
			status[e.x][e.y][e.orient][e.comm][0] = 1;
					my_queue.push(e);
					continue;
				}
				if (e.orient == down && e.y != (w - 1) && hw[e.x][e.y + 1] != 'X' 
						&& !status[e.x][e.y + 1][e.orient][(e.comm + 1)% n_comm ][0]){
					e.y += 1;
					e.comm = (e.comm + 1) % n_comm;
					//cout << "-- " << e.x << ":" << e.y << ", " << e.orient << ", " << e.comm << endl;
			status[e.x][e.y][e.orient][e.comm][0] = 1;
					my_queue.push(e);
					continue;
				}
				if (e.orient == left && e.x != 0 && hw[e.x - 1][e.y] != 'X' 
						&& !status[e.x - 1][e.y][e.orient][(e.comm + 1)% n_comm ][0]){
					e.x -= 1;
					e.comm = (e.comm + 1) % n_comm;
					//cout << "-- " << e.x << ":" << e.y << ", " << e.orient << ", " << e.comm << endl;
			status[e.x][e.y][e.orient][e.comm][0] = 1;
					my_queue.push(e);
					continue;
				}
				if (e.orient == right && e.x != (h - 1) && hw[e.x + 1][e.y] != 'X' 
						&& !status[e.x + 1][e.y][e.orient][(e.comm + 1)% n_comm ][0]){
					e.x += 1;
					e.comm = (e.comm + 1) % n_comm;
					//cout << "-- " << e.x << ":" << e.y << ", " << e.orient << ", " << e.comm << endl;
			status[e.x][e.y][e.orient][e.comm][0] = 1;
					my_queue.push(e);
					continue;
				}

			}
			if (comms[e.comm] == 'R' &&  !status[e.x][e.y][(e.orient + 1) % 4][(e.comm + 1)% n_comm ][0]) {
				e.orient = (e.orient + 1) % 4;
				//cout << "-- " << e.x << ":" << e.y << ", " << e.orient << ", " << e.comm << endl;
			status[e.x][e.y][e.orient][e.comm][0] = 1;
				my_queue.push(e);
				continue;
			}
			if (comms[e.comm] == 'L' &&  !status[e.x][e.y][(e.orient + 3) % 4][(e.comm + 1)% n_comm ][0]) {
				e.orient = (e.orient + 3) % 4;
				//cout << "-- " << e.x << ":" << e.y << ", " << e.orient << ", " << e.comm << endl;
			status[e.x][e.y][e.orient][e.comm][0] = 1;
				my_queue.push(e);
				continue;
			}
		}


	}
	
	return 0;
}


